changeset 65:2d866edd79d5

Merge from noexcept branch
author Chris Cannam <c.cannam@qmul.ac.uk>
date Fri, 23 Sep 2016 14:23:10 +0100
parents 85ec33975434 (diff) 0ea374ea96a2 (current diff)
children 6f160dee1192
files json/VampJson.h json/json-test.cpp utilities/json-cli.cpp utilities/json-to-capnp.cpp
diffstat 4 files changed, 126 insertions(+), 39 deletions(-) [+]
line wrap: on
line diff
--- a/capnproto/VampnProto.h	Wed Sep 21 12:59:35 2016 +0100
+++ b/capnproto/VampnProto.h	Fri Sep 23 14:23:10 2016 +0100
@@ -127,11 +127,8 @@
     }
 
     static void
-    buildOutputDescriptor(OutputDescriptor::Builder &b,
-                          const Vamp::Plugin::OutputDescriptor &od) {
-
-        auto basic = b.initBasic();
-        buildBasicDescriptor(basic, od);
+    buildConfiguredOutputDescriptor(ConfiguredOutputDescriptor::Builder &b,
+                                    const Vamp::Plugin::OutputDescriptor &od) {
 
         b.setUnit(od.unit);
 
@@ -162,10 +159,19 @@
     }
 
     static void
-    readOutputDescriptor(Vamp::Plugin::OutputDescriptor &od,
-                         const OutputDescriptor::Reader &r) {
+    buildOutputDescriptor(OutputDescriptor::Builder &b,
+                          const Vamp::Plugin::OutputDescriptor &od) {
 
-        readBasicDescriptor(od, r.getBasic());
+        auto basic = b.initBasic();
+        buildBasicDescriptor(basic, od);
+
+        auto configured = b.initConfigured();
+        buildConfiguredOutputDescriptor(configured, od);
+    }
+    
+    static void
+    readConfiguredOutputDescriptor(Vamp::Plugin::OutputDescriptor &od,
+                                   const ConfiguredOutputDescriptor::Reader &r) {
 
         od.unit = r.getUnit();
 
@@ -195,6 +201,14 @@
     }
 
     static void
+    readOutputDescriptor(Vamp::Plugin::OutputDescriptor &od,
+                         const OutputDescriptor::Reader &r) {
+
+        readBasicDescriptor(od, r.getBasic());
+        readConfiguredOutputDescriptor(od, r.getConfigured());
+    }
+
+    static void
     buildParameterDescriptor(ParameterDescriptor::Builder &b,
                              const Vamp::Plugin::ParameterDescriptor &pd) {
 
@@ -685,10 +699,10 @@
                            const Vamp::HostExt::ListResponse &resp) {
         b.setSuccess(true);
         auto r = b.getResponse().initList();
-        auto p = r.initPlugins(resp.pluginData.size());
-        for (size_t i = 0; i < resp.pluginData.size(); ++i) {
+        auto p = r.initPlugins(resp.plugins.size());
+        for (size_t i = 0; i < resp.plugins.size(); ++i) {
             auto pd = p[i];
-            buildPluginStaticData(pd, resp.pluginData[i]);
+            buildPluginStaticData(pd, resp.plugins[i]);
         }
     }
     
@@ -844,13 +858,13 @@
         if (getRequestResponseType(r) != RRType::List) {
             throw std::logic_error("not a list response");
         }
-        resp.pluginData.clear();
+        resp.plugins.clear();
         if (r.getSuccess()) {
             auto pp = r.getResponse().getList().getPlugins();
             for (const auto &p: pp) {
                 Vamp::HostExt::PluginStaticData psd;
                 readPluginStaticData(psd, p);
-                resp.pluginData.push_back(psd);
+                resp.plugins.push_back(psd);
             }
         }
     }
--- a/capnproto/vamp.capnp	Wed Sep 21 12:59:35 2016 +0100
+++ b/capnproto/vamp.capnp	Fri Sep 23 14:23:10 2016 +0100
@@ -49,20 +49,24 @@
     valueNames         @7  :List(Text)  = [];
 }
 
+struct ConfiguredOutputDescriptor {
+    unit               @0  :Text;
+    hasFixedBinCount   @1  :Bool        = false;
+    binCount           @2  :Int32       = 0;
+    binNames           @3  :List(Text)  = [];
+    hasKnownExtents    @4  :Bool        = false;
+    minValue           @5  :Float32     = 0.0;
+    maxValue           @6  :Float32     = 0.0;
+    isQuantized        @7  :Bool        = false;
+    quantizeStep       @8  :Float32     = 0.0;
+    sampleType         @9  :SampleType;
+    sampleRate         @10 :Float32     = 0.0;
+    hasDuration        @11 :Bool        = false;
+}
+
 struct OutputDescriptor {
     basic              @0  :Basic;
-    unit               @1  :Text;
-    hasFixedBinCount   @2  :Bool        = false;
-    binCount           @3  :Int32       = 0;
-    binNames           @4  :List(Text)  = [];
-    hasKnownExtents    @5  :Bool        = false;
-    minValue           @6  :Float32     = 0.0;
-    maxValue           @7  :Float32     = 0.0;
-    isQuantized        @8  :Bool        = false;
-    quantizeStep       @9  :Float32     = 0.0;
-    sampleType         @10 :SampleType;
-    sampleRate         @11 :Float32     = 0.0;
-    hasDuration        @12 :Bool        = false;
+    configured         @1  :ConfiguredOutputDescriptor;
 }
 
 struct PluginStaticData {
--- a/json/VampJson.h	Wed Sep 21 12:59:35 2016 +0100
+++ b/json/VampJson.h	Fri Sep 23 14:23:10 2016 +0100
@@ -212,9 +212,8 @@
     }
 
     static json11::Json
-    fromOutputDescriptor(const Vamp::Plugin::OutputDescriptor &desc) {
+    fromConfiguredOutputDescriptor(const Vamp::Plugin::OutputDescriptor &desc) {
         json11::Json::object jo {
-            { "basic", fromBasicDescriptor(desc) },
             { "unit", desc.unit },
             { "sampleType", fromSampleType(desc.sampleType) },
             { "sampleRate", desc.sampleRate },
@@ -234,8 +233,17 @@
         return json11::Json(jo);
     }
     
+    static json11::Json
+    fromOutputDescriptor(const Vamp::Plugin::OutputDescriptor &desc) {
+        json11::Json::object jo {
+            { "basic", fromBasicDescriptor(desc) },
+            { "configured", fromConfiguredOutputDescriptor(desc) }
+        };
+        return json11::Json(jo);
+    }
+    
     static Vamp::Plugin::OutputDescriptor
-    toOutputDescriptor(json11::Json j, std::string &err) {
+    toConfiguredOutputDescriptor(json11::Json j, std::string &err) {
 
         Vamp::Plugin::OutputDescriptor od;
         if (!j.is_object()) {
@@ -243,9 +251,6 @@
             return {};
         }
     
-        toBasicDescriptor(j["basic"], od, err);
-        if (failed(err)) return {};
-
         od.unit = j["unit"].string_value();
 
         od.sampleType = toSampleType(j["sampleType"].string_value(), err);
@@ -286,6 +291,24 @@
 
         return od;
     }
+    
+    static Vamp::Plugin::OutputDescriptor
+    toOutputDescriptor(json11::Json j, std::string &err) {
+
+        Vamp::Plugin::OutputDescriptor od;
+        if (!j.is_object()) {
+            err = "object expected for output descriptor";
+            return {};
+        }
+
+        od = toConfiguredOutputDescriptor(j, err);
+        if (failed(err)) return {};
+    
+        toBasicDescriptor(j["basic"], od, err);
+        if (failed(err)) return {};
+
+        return od;
+    }
 
     static json11::Json
     fromParameterDescriptor(const Vamp::PluginBase::ParameterDescriptor &desc) {
@@ -1005,7 +1028,7 @@
         jo["success"] = true;
 
         json11::Json::array arr;
-        for (const auto &a: resp.pluginData) {
+        for (const auto &a: resp.plugins) {
             arr.push_back(fromPluginStaticData(a));
         }
         json11::Json::object po;
@@ -1193,7 +1216,7 @@
         Vamp::HostExt::ListResponse resp;
         if (successful(j, err) && !failed(err)) {
             for (const auto &a: j["content"]["plugins"].array_items()) {
-                resp.pluginData.push_back(toPluginStaticData(a, err));
+                resp.plugins.push_back(toPluginStaticData(a, err));
                 if (failed(err)) return {};
             }
         }
--- a/test/test-vampipe-server.sh	Wed Sep 21 12:59:35 2016 +0100
+++ b/test/test-vampipe-server.sh	Fri Sep 23 14:23:10 2016 +0100
@@ -1,11 +1,58 @@
-#!/bin/bash
+#!/bin/bash 
 
-( bin/vampipe-convert request -i json -o capnp |
-	VAMP_PATH=./vamp-plugin-sdk/examples bin/vampipe-server |
+set -eu
 
-#	capnp decode capnproto/vamp.capnp VampResponse
+reqfile="/tmp/$$.req.json"
+respfile="/tmp/$$.resp.json"
+trap "rm -f $reqfile $respfile" 0
 
-	bin/vampipe-convert response -i capnp -o json
+schema=vamp-json-schema/schema
+
+validate() {
+    local file="$1"
+    local schemaname="$2"
+    jsonschema -i "$file" "$schema/$schemaname.json" 1>&2 && \
+        echo "validated $schemaname" 1>&2 || \
+        echo "failed to validate $schemaname" 1>&2
+}
+
+validate_request() {
+    local json="$1"
+    echo "$json" > "$reqfile"
+    validate "$reqfile" "request"
+    type=$(grep '"type":' "$reqfile" | sed 's/^.*"type": *"\([^"]*\)".*$/\1/')
+    if [ "$type" == "configure" ]; then type=configuration; fi
+    if [ "$type" != "list" ]; then
+        echo "$json" | 
+            sed 's/^.*"content"://' |
+            sed 's/}}$/}/' > "$reqfile"
+        validate "$reqfile" "${type}request"
+    fi
+}
+
+validate_response() {
+    local json="$1"
+    echo "$json" > "$respfile"
+    validate "$respfile" "response"
+    type=$(grep '"type":' "$respfile" | sed 's/^.*"type": "\([^"]*\)".*$/\1/')
+    if [ "$type" == "configure" ]; then type=configuration; fi
+    echo "$json" | 
+        sed 's/^.*"content"://' |
+        sed 's/, "error.*$//' |
+        sed 's/, "success.*$//' > "$respfile"
+    validate "$respfile" "${type}response"
+}
+
+( while read request ; do
+      validate_request "$request"
+      echo "$request"
+  done |
+      bin/vampipe-convert request -i json -o capnp |
+      VAMP_PATH=./vamp-plugin-sdk/examples bin/vampipe-server |
+      bin/vampipe-convert response -i capnp -o json |
+      while read response ; do
+          validate_response "$response"
+      done
 ) <<EOF
 {"type":"list"}
 {"type":"load","content": {"pluginKey":"vamp-example-plugins:percussiononsets","inputSampleRate":44100,"adapterFlags":["AdaptInputDomain","AdaptBufferSize"]}}
@@ -13,4 +60,3 @@
 {"type":"process","content": {"pluginHandle": 1, "processInput": { "timestamp": {"s": 0, "n": 0}, "inputBuffers": [{"values": [1,2,3,4,5,6,7,8]}]}}}
 {"type":"finish","content": {"pluginHandle": 1}}
 EOF
-